//
//  MWImageScaler.h
//  Malkinware
//
//  Created by Jim McGowan on 19/5/12.
//  Copyright (c) 2012 Jim McGowan. All rights reserved.
//

#import <Cocoa/Cocoa.h>
#import <QuartzCore/QuartzCore.h>
#import "NSImageExtensions.h"
#import "MWLog.h"

@interface MWImageScaler : NSObject

- (instancetype)initWithInputImage:(NSImage *)image;
- (void)setInputImage:(NSImage *)image;

@property CGFloat pixelWidth;
@property CGFloat pixelHeight;
@property CGFloat pointWidth;
@property CGFloat pointHeight;
@property CGFloat longestSideInPoints;
@property CGFloat longestSideInPixels;
@property CGFloat scaleFactor;
@property CGFloat dpi;


// scaledImage returns an NSImage with a single bitmap representation, scaled as per the properties.
@property (nonatomic, readonly, copy) NSImage *scaledImage;


@end
