//
//  MWTextTokenView.h
//  Malkinware
//
//  Created by Jim McGowan on 15/3/13.
//  Copyright (c) 2013 Malkinware. All rights reserved.
//
//  NOTE: Uses the focus ring API introduced 10.7
//

#import <Cocoa/Cocoa.h>
#import "MWLog.h"
#import "MWTokenCell.h"

@interface MWTokenView : NSTextField

@property (strong) id representedObject;
@property (nonatomic, copy) NSAttributedString *displayString;
@property (copy) NSColor *baseColor;
@property (copy) NSColor *selectedColor;

// A shadow is added to a token image when it is being dragged.  Therefore the size of the dragged image is larger than the frame of the token view
// -draggingImagaeSize returns the size of the dragging image (token + shadow)
// -draggingImageContentsOrigin returns the origin of the token within the dragging image.
- (NSSize)draggingImageSize;
- (NSPoint)draggingImageContentsOrigin;
- (NSImage *)draggingImage;

@end


@interface MWHeaderTokenView : MWTokenView
// Header tokens cannot be selected or edited
@end
