//
//  MWUUID.h
//  Malkinware
//
//  Created by Jim McGowan on 15/6/13.
//  Copyright (c) 2013 Jim McGowan. All rights reserved.
//
//  This class is a feature-matched, drop-in replacement for NSUUID on pre 10.8
//

#import <Foundation/Foundation.h>
#import <CoreFoundation/CFUUID.h>

@interface MWUUID : NSObject <NSCopying, NSSecureCoding>

+ (instancetype)UUID;
- (instancetype)init NS_DESIGNATED_INITIALIZER;
- (instancetype)initWithUUIDBytes:(const uuid_t)bytes NS_DESIGNATED_INITIALIZER;
- (instancetype)initWithUUIDString:(NSString *)string NS_DESIGNATED_INITIALIZER;

- (void)getUUIDBytes:(uuid_t)uuid;
@property (nonatomic, readonly, copy) NSString *UUIDString;


@end
