//
//  NSStringExtensions.h
//  Malkinware
//
//  Created by Jim McGowan on 13/04/2008.
//  Copyright 2008 Jim McGowan. All rights reserved.
//

#import <Foundation/Foundation.h>
#import "MWLog.h"


@interface NSString (MWNSStringExtensions)

+ (NSString *)stringWithUUID;
+ (NSString *)stringWithContentsOfPlainTextFileOfUnknownEncoding:(NSURL *)fileURL usedEncoding:(NSStringEncoding *)out_fileEncoding; // May return nil if encoding cannot be determined

@property (NS_NONATOMIC_IOSONLY, readonly, copy) NSString *firstCharacter;
@property (NS_NONATOMIC_IOSONLY, readonly, copy) NSString *lastCharacter;

@property (NS_NONATOMIC_IOSONLY, readonly, copy) NSString *stringByRemovingTrailingWhiteSpace;
@property (NS_NONATOMIC_IOSONLY, readonly, copy) NSString *stringByRemovingLeadingWhiteSpace;
@property (NS_NONATOMIC_IOSONLY, readonly, copy) NSString *stringByRemovingLeadingAndTrailingWhiteSpace;
@property (NS_NONATOMIC_IOSONLY, readonly, copy) NSString *stringByRemovingTrailingPeriod;
@property (NS_NONATOMIC_IOSONLY, readonly, copy) NSString *stringByRemovingTrailingWhiteSpaceAndPunctuation;	// does not remove a final '.'
@property (NS_NONATOMIC_IOSONLY, readonly, copy) NSString *stringByRemovingLeadingWhiteSpaceAndPunctuation;
@property (NS_NONATOMIC_IOSONLY, readonly, copy) NSString *stringByRemovingLeadingAndTrailingWhiteSpaceAndPunctuation;
- (NSString *)stringByRemovingCharactersInSet:(NSCharacterSet *)set;

@property (NS_NONATOMIC_IOSONLY, readonly, copy) NSString *stringByConvertingLiteralOrdinalsToNumeric;	// does 1 - 10 only

- (NSString *)stringByPercentEncodingCharactersInSet:(NSCharacterSet *)charSet;

@property (NS_NONATOMIC_IOSONLY, readonly, copy) NSString *sentenceCapitalizedString;

#pragma mark 10.7 Compatibility Code
@property (NS_NONATOMIC_IOSONLY, readonly, copy) NSString *capitalizedString_WithCurrentLocaleIfAvailable; // uses -capitalizedStringWithLocale:[NSLocale currentLocale] on 10.8+ or -capitalizedString on earlier systems
@property (NS_NONATOMIC_IOSONLY, readonly, copy) NSString *lowercaseString_WithCurrentLocaleIfAvailable;
@property (NS_NONATOMIC_IOSONLY, readonly, copy) NSString *uppercaseString_WithCurrentLocaleIfAvailable;

@end
